"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.GrantRole = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * The ``postgresql.GrantRole`` resource creates and manages membership in a role to one or more other roles in a non-authoritative way.
 *
 * When using ``postgresql.GrantRole`` resource it is likely because the PostgreSQL role you are modifying was created outside of this provider.
 *
 * > **Note:** This resource needs PostgreSQL version 9 or above.
 *
 * ## Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as postgresql from "@pulumi/postgresql";
 *
 * const grantRoot = new postgresql.GrantRole("grant_root", {
 *     role: "root",
 *     grantRole: "application",
 *     withAdminOption: true,
 * });
 * ```
 *
 * > **Note:** If you use `postgresql.GrantRole` for a role that you also manage with a `postgresql.Role` resource, you need to ignore the changes of the `roles` attribute in the `postgresql.Role` resource or they will fight over what your role grants should be. e.g.:
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as postgresql from "@pulumi/postgresql";
 *
 * const bob = new postgresql.Role("bob", {name: "bob"});
 * const bobAdmin = new postgresql.GrantRole("bob_admin", {
 *     role: "bob",
 *     grantRole: "admin",
 * });
 * ```
 */
class GrantRole extends pulumi.CustomResource {
    /**
     * Get an existing GrantRole resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new GrantRole(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of GrantRole.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === GrantRole.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["grantRole"] = state ? state.grantRole : undefined;
            resourceInputs["role"] = state ? state.role : undefined;
            resourceInputs["withAdminOption"] = state ? state.withAdminOption : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.grantRole === undefined) && !opts.urn) {
                throw new Error("Missing required property 'grantRole'");
            }
            if ((!args || args.role === undefined) && !opts.urn) {
                throw new Error("Missing required property 'role'");
            }
            resourceInputs["grantRole"] = args ? args.grantRole : undefined;
            resourceInputs["role"] = args ? args.role : undefined;
            resourceInputs["withAdminOption"] = args ? args.withAdminOption : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(GrantRole.__pulumiType, name, resourceInputs, opts);
    }
}
exports.GrantRole = GrantRole;
/** @internal */
GrantRole.__pulumiType = 'postgresql:index/grantRole:GrantRole';
//# sourceMappingURL=grantRole.js.map