"use strict";
// *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
// *** Do not edit by hand unless you're certain you know what you are doing! ***
Object.defineProperty(exports, "__esModule", { value: true });
exports.Server = void 0;
const pulumi = require("@pulumi/pulumi");
const utilities = require("./utilities");
/**
 * The ``postgresql.Server`` resource creates and manages a foreign server on a PostgreSQL server.
 *
 * ## Usage
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as postgresql from "@pulumi/postgresql";
 *
 * const extPostgresFdw = new postgresql.Extension("ext_postgres_fdw", {name: "postgres_fdw"});
 * const myserverPostgres = new postgresql.Server("myserver_postgres", {
 *     serverName: "myserver_postgres",
 *     fdwName: "postgres_fdw",
 *     options: {
 *         host: "foo",
 *         dbname: "foodb",
 *         port: "5432",
 *     },
 * }, {
 *     dependsOn: [extPostgresFdw],
 * });
 * ```
 *
 * ```typescript
 * import * as pulumi from "@pulumi/pulumi";
 * import * as postgresql from "@pulumi/postgresql";
 *
 * const extFileFdw = new postgresql.Extension("ext_file_fdw", {name: "file_fdw"});
 * const myserverFile = new postgresql.Server("myserver_file", {
 *     serverName: "myserver_file",
 *     fdwName: "file_fdw",
 * }, {
 *     dependsOn: [extFileFdw],
 * });
 * ```
 */
class Server extends pulumi.CustomResource {
    /**
     * Get an existing Server resource's state with the given name, ID, and optional extra
     * properties used to qualify the lookup.
     *
     * @param name The _unique_ name of the resulting resource.
     * @param id The _unique_ provider ID of the resource to lookup.
     * @param state Any extra arguments used during the lookup.
     * @param opts Optional settings to control the behavior of the CustomResource.
     */
    static get(name, id, state, opts) {
        return new Server(name, state, Object.assign(Object.assign({}, opts), { id: id }));
    }
    /**
     * Returns true if the given object is an instance of Server.  This is designed to work even
     * when multiple copies of the Pulumi SDK have been loaded into the same process.
     */
    static isInstance(obj) {
        if (obj === undefined || obj === null) {
            return false;
        }
        return obj['__pulumiType'] === Server.__pulumiType;
    }
    constructor(name, argsOrState, opts) {
        let resourceInputs = {};
        opts = opts || {};
        if (opts.id) {
            const state = argsOrState;
            resourceInputs["dropCascade"] = state ? state.dropCascade : undefined;
            resourceInputs["fdwName"] = state ? state.fdwName : undefined;
            resourceInputs["options"] = state ? state.options : undefined;
            resourceInputs["serverName"] = state ? state.serverName : undefined;
            resourceInputs["serverOwner"] = state ? state.serverOwner : undefined;
            resourceInputs["serverType"] = state ? state.serverType : undefined;
            resourceInputs["serverVersion"] = state ? state.serverVersion : undefined;
        }
        else {
            const args = argsOrState;
            if ((!args || args.fdwName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'fdwName'");
            }
            if ((!args || args.serverName === undefined) && !opts.urn) {
                throw new Error("Missing required property 'serverName'");
            }
            resourceInputs["dropCascade"] = args ? args.dropCascade : undefined;
            resourceInputs["fdwName"] = args ? args.fdwName : undefined;
            resourceInputs["options"] = args ? args.options : undefined;
            resourceInputs["serverName"] = args ? args.serverName : undefined;
            resourceInputs["serverOwner"] = args ? args.serverOwner : undefined;
            resourceInputs["serverType"] = args ? args.serverType : undefined;
            resourceInputs["serverVersion"] = args ? args.serverVersion : undefined;
        }
        opts = pulumi.mergeOptions(utilities.resourceOptsDefaults(), opts);
        super(Server.__pulumiType, name, resourceInputs, opts);
    }
}
exports.Server = Server;
/** @internal */
Server.__pulumiType = 'postgresql:index/server:Server';
//# sourceMappingURL=server.js.map